<?php
   function bhomatic_items_panel()
{
   $bhomatic_Main_Settings = get_option('bhomatic_Main_Settings', false);
   if(isset($bhomatic_Main_Settings['app_id']) && $bhomatic_Main_Settings['app_id'] != '')
   {
   }
   else
   {
   ?>
<h1><?php echo esc_html__("You must add a Behance API Key before you can use this feature!", 'bhomatic-behance-post-generator');?></h1>
<?php
    return;
   }
   ?>
<div class="wp-header-end"></div>
<div class="wrap gs_popuptype_holder seo_pops">
   <div>
      <div>
         <div>
            <form id="myForm" method="post" action="admin.php?page=bhomatic_items_panel">
               <?php
                  wp_nonce_field('bhomatic_save_rules', '_bhomaticr_nonce');
                  if (isset($_GET['settings-updated'])) {
                  ?>
               <div>
                  <p class="cr_saved_notif"><strong><?php echo esc_html__("Settings saved.", 'bhomatic-behance-post-generator');?></strong></p>
               </div>
               <?php
                  }
                  ?>
               <div>
                  <div class="hideMain">
                     <hr/>
                     <div class="table-responsive">
                        <table id="mainRules" class="responsive table cr_main_table">
                           <thead>
                              <tr>
                                 <th>
                                    <?php echo esc_html__("ID", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("This is the ID of the rule. ", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                                 <th>
                                    <?php echo esc_html__("Search Query", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("Please input your search query for the project search - Update: nested shortcodes also supported (shortcodes generated by rules from other plugins).", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                                 <th>
                                    <?php echo esc_html__("Schedule", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             $unlocker = get_option('bhomatic_minute_running_unlocked', false);
                                             if($unlocker == '1')
                                             {
                                                 echo esc_html__("Select the interval in minutes after which you want this rule to run. Defined in minutes.", 'bhomatic-behance-post-generator');
                                             }
                                             else
                                             {
                                                 echo esc_html__("Select the interval in hours after which you want this rule to run. Defined in hours.", 'bhomatic-behance-post-generator');
                                             }
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                                 <th>
                                    <?php echo esc_html__("Max # Posts", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("Select the maximum number of posts that this rule can create at once. 0-200 interval allowed.", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                                 <th>
                                    <?php echo esc_html__("Post Status", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("Select the status that you want for the automatically generated posts to have.", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                                 <th>
                                    <?php echo esc_html__("Item Type", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("Select the type (post/page) for your automatically generated item.", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                                 <th>
                                    <?php echo esc_html__("Post Author", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("Select the author that you want to assign for the automatically generated posts.", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                                 <th>
                                    <?php echo esc_html__("More Options", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("Shows advanced settings for this rule.", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                                 <th class="cr_max_width_20">
                                    <?php echo esc_html__("Del", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("Do you want to delete this rule?", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                                 <th class="cr_max_42">
                                    <?php echo esc_html__("Active", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("Do you want to enable this rule? You can deactivate any rule (you don't have to delete them to deactivate them).", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                    <br/>
                                    <input type="checkbox" onchange="thisonChangeHandler(this)" id="exclusion">
                                 </th>
                                 <th class="cr_max_32">
                                    <?php echo esc_html__("Info", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("The number of items (posts, pages) this rule has generated so far.", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                                 <th class="cr_actions">
                                    <?php echo esc_html__("Actions", 'bhomatic-behance-post-generator');?>
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("Do you want to run this rule now? Note that only one instance of a rule is allowed at once.", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </th>
                              </tr>
                              
                           </thead>
                           <tbody>
                              <?php
                                 echo bhomatic_expand_rules_manual();
                                 ?>
                              
                              <tr>
                                 <td class="cr_short_td">-</td>
                                 <td class="cr_select_option"><input type="text" name="bhomatic_rules_list[textids][]" class="cr_width_full" placeholder="Search query" value=""/></td>
                                 <td class="cr_comm_td"><input type="number" step="1" min="1" name="bhomatic_rules_list[schedule][]" max="8765812" class="cr_width_60" placeholder="Select the rule schedule interval" value="24"/></td>
                                 <td class="cr_comm_td"><input type="number" step="1" min="0" max="200" name="bhomatic_rules_list[max][]" placeholder="Select the max # of generated posts" value="10" class="cr_width_60"/></td>
                                 <td class="cr_status">
                                    <select id="submit_status" name="bhomatic_rules_list[submit_status][]" class="cr_width_70">
                                       <option value="pending"><?php echo esc_html__("Pending -> Moderate", 'bhomatic-behance-post-generator');?></option>
                                       <option value="draft"><?php echo esc_html__("Draft -> Moderate", 'bhomatic-behance-post-generator');?></option>
                                       <option value="publish" selected><?php echo esc_html__("Published", 'bhomatic-behance-post-generator');?></option>
                                       <option value="private"><?php echo esc_html__("Private", 'bhomatic-behance-post-generator');?></option>
                                       <option value="trash"><?php echo esc_html__("Trash", 'bhomatic-behance-post-generator');?></option>
                                    </select>
                                 </td>
                                 <td class="cr_comm_td"><select id="default_type" name="bhomatic_rules_list[default_type][]" class="cr_width_auto">
                                    <?php
                                       $is_first = true;
                                       foreach ( get_post_types( '', 'names' ) as $post_type ) {
                                          echo '<option value="' . esc_attr($post_type) . '"';
                                          if($is_first === true)
                                          {
                                              echo ' selected';
                                              $is_first = false;
                                          }
                                          echo '>' . esc_html($post_type) . '</option>';
                                       }
                                       ?>
                                    </select>  
                                 </td>
                                 <td class="cr_author"><select id="post_author" name="bhomatic_rules_list[post_author][]" class="cr_width_auto cr_max_width_150">
                                    <?php
                                       $blogusers = get_users( [ 'role__in' => [ 'contributor', 'author', 'editor', 'administrator' ] ] );
                                       foreach ($blogusers as $user) {
                                           echo '<option value="' . esc_html($user->ID) . '"';
                                           echo '>' . esc_html($user->display_name) . '</option>';
                                       }
                                       ?>
                                    </select>  
                                 </td>
                                 <td class="cr_width_70">
                                    <input type="button" id="mybtnfzr" value="Settings">
                                    <div id="mymodalfzr" class="codemodalfzr">
                                       <div class="codemodalfzr-content">
                                          <div class="codemodalfzr-header">
                                             <span id="bhomatic_close" class="codeclosefzr">&times;</span>
                                             <h2><span class="cr_color_white"><?php echo esc_html__("New Rule", 'bhomatic-behance-post-generator');?></span> <?php echo esc_html__("Advanced Settings", 'bhomatic-behance-post-generator');?></h2>
                                          </div>
                                          <div class="codemodalfzr-body">
                                             <div class="table-responsive">
                                                <table class="responsive table cr_main_table_nowr">
                                                   <tr>
                                                      <td class="cr_min_width_200">
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Set the title of the generated posts for user rules. You can use the following shortcodes: %%item_short_content%%, %%author%%, %%item_description%%, %%item_date%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_cat%%, %%item_tags%%", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Generated Post Title:", 'bhomatic-behance-post-generator');?></b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                                                      </td>
                                                      <td>
                                                      <input type="text" name="bhomatic_rules_list[post_title][]" value="%%item_title%%" placeholder="Please insert your desired post title. Example: %%item_title%%" class="cr_width_full">
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td class="cr_min_width_200">
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Set the content of the generated posts for user rules. You can use the following shortcodes: %%item_date%%, %%custom_html%%, %%custom_html2%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_content_plain_text%%, %%item_url%%, %%item_cat%%, %%item_tags%%, %%item_read_more_button%%, %%item_show_image%%, %%item_image_URL%%, %%author%%, %%author_link%%, %%item_modified%%, %%item_created%%, %%item_conceived%%, %%item_is_mature%%, %%item_views%%, %%item_appreciations%%, %%item_comments%%, %%item_fields%%, %%item_creator_id%%, %%item_copyright%%, %%item_tools%%", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Generated Post Content:", 'bhomatic-behance-post-generator');?></b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                                                      </td>
                                                      <td>
                                                      <textarea rows="2" cols="70" name="bhomatic_rules_list[post_content][]" placeholder="Please insert your desired post content. Example:%%item_content%%" class="cr_width_full">%%item_content%%</textarea>
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Select the Behance post type you want to skip. Possible values are: text, image, embed, media_collection, audio, video.", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Behance Post Types To Skip:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="text" id="post_type_filter" name="bhomatic_rules_list[post_type_filter][]" value="" placeholder="Input a list of post types" class="cr_width_full">              
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Do you want to get additional information for each project? Please note that this feature will make one additional API request for each posted project. If you uncheck this checkbox, the following shortcodes will become unavailable: %%item_fields%%, %%item_creator_id%%, %%item_copyright%%, %%item_tools%%, %%item_content%%", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Get Detailed Info For Projects:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="checkbox" id="get_details" name="bhomatic_rules_list[get_details][]" checked>
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Do you want to get additional information for each project? Please note that this feature will make one additional API request for each posted project.", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Skip Mature Content:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="checkbox" id="skip_mature" name="bhomatic_rules_list[skip_mature][]" checked>
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Do you want to remember last posted item and continue search from it the next time the importing rule runs?", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Cache Items For Continuous Posting (disable to get latest posts only):", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="checkbox" id="continue_search" name="bhomatic_rules_list[continue_search][]" checked>
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td class="cr_min_width_200">
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("The order the results are returned in. Possible values: featured_date (default), appreciations, views, comments, published_date.", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Result Sorting:", 'bhomatic-behance-post-generator');?></b>   
                                                      </td>
                                                      <td class="cr_min_width_200">
                                                      <select id="post_sort" name="bhomatic_rules_list[post_sort][]" class="cr_width_full">
                                                      <option value="featured_date" selected><?php echo esc_html__("Featured Date", 'bhomatic-behance-post-generator');?></option>
                                                      <option value="appreciations"><?php echo esc_html__("Appreciations", 'bhomatic-behance-post-generator');?></option>
                                                      <option value="views"><?php echo esc_html__("Views", 'bhomatic-behance-post-generator');?></option>
                                                      <option value="comments"><?php echo esc_html__("Comments", 'bhomatic-behance-post-generator');?></option>
                                                      <option value="published_date"><?php echo esc_html__("Published Date", 'bhomatic-behance-post-generator');?></option>
                                                      </select>     
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td class="cr_min_width_200">
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Limits the search by time. Possible values: all (default), today, week, month.", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Search Time:", 'bhomatic-behance-post-generator');?></b>   
                                                      </td>
                                                      <td class="cr_min_width_200">
                                                      <select id="post_time" name="bhomatic_rules_list[post_time][]" class="cr_width_full">
                                                      <option value="all" selected><?php echo esc_html__("All", 'bhomatic-behance-post-generator');?></option>
                                                      <option value="today"><?php echo esc_html__("Today", 'bhomatic-behance-post-generator');?></option>
                                                      <option value="week"><?php echo esc_html__("Week", 'bhomatic-behance-post-generator');?></option>
                                                      <option value="month"><?php echo esc_html__("Month", 'bhomatic-behance-post-generator');?></option>
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr><td class="cr_min_width_200">
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Filter by creative license. Acronyms found here: http://creativecommons.org/licenses/", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Search License:", 'bhomatic-behance-post-generator');?></b>   
                                                   </td><td class="cr_min_width_200">
                                                   <select id="post_license" name="bhomatic_rules_list[post_license][]" class="cr_width_full">
                                                   <option value="any" selected><?php echo esc_html__("Any", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="cc by"><?php echo esc_html__("CC BY", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="cc by-sa"><?php echo esc_html__("CC BY-SA", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="cc by-nd"><?php echo esc_html__("CC BY-ND", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="cc by-nc"><?php echo esc_html__("CC BY-NC", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="cc by-nc-sa"><?php echo esc_html__("CC BY-NC-SA", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="cc by-nc-nd"><?php echo esc_html__("CC BY-NC-ND", 'bhomatic-behance-post-generator');?></option>
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo sprintf( wp_kses( __( "Limits the search by creative field. Accepts a URL-encoded field name from the list of defined creative fields. <a href='%s' target='_blank'>Value list (at the lower part of the page)</a>", 'bhomatic-behance-post-generator'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), esc_url_raw( 'https://www.behance.net/dev/api/endpoints/' ) );
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Search Project Field:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="text" id="post_field" name="bhomatic_rules_list[post_field][]" value="" placeholder="Input a post field slug" class="cr_width_full">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Limits the search by tags. Accepts one tag name or a pipe-separated list of tag names.", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Search Project Tags:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="text" id="post_tags" name="bhomatic_rules_list[post_tags][]" value="" placeholder="Input a post tag slug" class="cr_width_full">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Limits the search by a 2-letter FIPS country code.", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Search Country:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="text" id="post_contry" name="bhomatic_rules_list[post_contry][]" value="" placeholder="Input a post country" class="cr_width_full">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Limits the search by state or province name.", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Search State:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="text" id="post_state" name="bhomatic_rules_list[post_state][]" value="" placeholder="Input a post state" class="cr_width_full">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Limits the search by city name.", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Search City:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="text" id="post_city" name="bhomatic_rules_list[post_city][]" value="" placeholder="Input a post city" class="cr_width_full">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Limit results to an RGB hex value (without #)", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Search Color Hex:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="text" id="color_hex" name="bhomatic_rules_list[color_hex][]" value="" placeholder="Input a color hex" class="cr_width_full">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("How closely to match the requested color_hex, in color shades (default:20) [0-255]", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Search Color Range:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="text" id="color_range" name="bhomatic_rules_list[color_range][]" value="" placeholder="Input a color range" class="cr_width_full">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Do you want to disable the automatic post excerpt generation?", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Disable Automatic Excerpt Generation:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="checkbox" id="no_excerpt" name="bhomatic_rules_list[no_excerpt][]">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Do you want to set post date as the original date from Behance?", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Set Post Original Date:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="checkbox" id="original_date" name="bhomatic_rules_list[original_date][]">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Do you want to strip images from generated content?", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Strip Images From Content:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="checkbox" id="strip_images" name="bhomatic_rules_list[strip_images][]">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Do you want to strip title from generated content and leave only images or videos?", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Strip Title From Content:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="checkbox" id="strip_text" name="bhomatic_rules_list[strip_text][]">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("This feature will try to remove the WordPress's default post category. This may fail in case no additional categories are added, because WordPress requires at least one post category for every post.", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Remove WP Default Post Category:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="checkbox" id="remove_default" name="bhomatic_rules_list[remove_default][]" checked>
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Do not include posts that's title or content does not contain at least one of these words. Separate words by comma. To disable this feature, leave this field blank.", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Required Words List:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="text" id="require_words" name="bhomatic_rules_list[require_words][]" value="" placeholder="Input some comma separated required words" class="cr_width_full">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Do not include posts that's title or content contains at least one of these words. Separate words by comma. To disable this feature, leave this field blank.", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Banned Words List:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="text" id="banned_words" name="bhomatic_rules_list[banned_words][]" value="" placeholder="Input some comma separated banned words" class="cr_width_full">
                                                   </div>
                                                   </td></tr><tr><td>
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("Do you want to limit the title's length to a specific word count? To disable this feature, leave this field blank.", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Limit Title Word Count:", 'bhomatic-behance-post-generator');?></b>
                                                   </td><td>
                                                   <input type="number" min="1" step="1" id="limit_title_word_count" name="bhomatic_rules_list[limit_title_word_count][]" value="" placeholder="Input a limit for the title" class="cr_width_full">
                                                   </div>
                                                   </td></tr><tr><td class="cr_min_width_200">
                                                   <div>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                   <div class="bws_hidden_help_text cr_min_260px">
                                                   <?php
                                                      echo esc_html__("If your template supports 'Post Formats', than you can select one here. If not, leave this at it's default value.", 'bhomatic-behance-post-generator');
                                                      ?>
                                                   </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Generated Post Format:", 'bhomatic-behance-post-generator');?></b>   
                                                   </td><td class="cr_min_width_200">
                                                   <select id="post_format" name="bhomatic_rules_list[post_format][]" class="cr_width_full">
                                                   <option value="post-format-standard"  selected><?php echo esc_html__("Standard", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="post-format-aside"><?php echo esc_html__("Aside", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="post-format-gallery"><?php echo esc_html__("Gallery", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="post-format-link"><?php echo esc_html__("Link", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="post-format-image"><?php echo esc_html__("Image", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="post-format-quote"><?php echo esc_html__("Quote", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="post-format-status"><?php echo esc_html__("Status", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="post-format-video"><?php echo esc_html__("Video", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="post-format-audio"><?php echo esc_html__("Audio", 'bhomatic-behance-post-generator');?></option>
                                                   <option value="post-format-chat"><?php echo esc_html__("Chat", 'bhomatic-behance-post-generator');?></option>
                                                   </select>     
                                                   </div>
                                                   </td></tr>
                                                   <tr>
                                                      <td class="cr_min_width_200">
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Select the post category that you want for the automatically generated posts to have.", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Additional Post Category:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <select multiple id="default_category" name="bhomatic_rules_list[default_category][]" class="cr_width_full" onmouseover="this.size=this.length;" onmouseout="this.size=4;">
                                                      <option value="bhomatic_no_category_12345678" selected><?php echo esc_html__("Do Not Add a Category", 'bhomatic-behance-post-generator');?></option>
                                                      <?php
                                                         $cat_args   = array(
                                                             'orderby' => 'name',
                                                             'hide_empty' => 0,
                                                             'order' => 'ASC'
                                                         );
                                                         $categories = get_categories($cat_args);
                                                         foreach ($categories as $category) {
                                                         ?>
                                                      <option value="<?php
                                                         echo esc_html($category->term_id);
                                                         ?>"><?php
                                                         echo esc_html(sanitize_text_field($category->name));
                                                         ?></option>
                                                      <?php
                                                         }
                                                         ?>
                                                      </select>     
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Do you want to automatically add post categories from the Behance items?", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Auto Add Categories:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="checkbox" id="auto_categories" name="bhomatic_rules_list[auto_categories][]">
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Do you want to automatically add post tags from the Behance items?", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Auto Add Tags:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="checkbox" id="auto_tags" name="bhomatic_rules_list[auto_tags][]">
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Select the post tags that you want for the automatically generated posts to have.", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Additional Post Tags:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="text" name="bhomatic_rules_list[default_tags][]" value="" placeholder="Please insert your additional post tags here" class="cr_width_full">
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Do you want to enable comments for the generated posts?", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Enable Comments For Posts:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="checkbox" id="enable_comments" name="bhomatic_rules_list[enable_comments][]" checked>
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Do you want to enable pingbacks/trackbacks for the generated posts?", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Enable Pingback/Trackback:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="checkbox" id="enable_pingback" name="bhomatic_rules_list[enable_pingback][]" checked>
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td class="cr_min_width_200">
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Set the custom fields that will be set for generated posts. The syntax for this field is the following: custom_field_name1 => custom_field_value1, custom_field_name2 => custom_field_value2, ... . In custom_field_valueX, you can use shortcodes, same like in post content. You can also assign the data to array custom fields, using this format: array_field[index_name1] => custom_field_value1, array_field[index_name2] => custom_field_value2. Example (without quotes): 'title_custom_field => %%item_title%%'. You can use the following shortcodes: %%item_pub_date%%, %%custom_html%%, %%custom_html2%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_content_plain_text%%, %%item_url%%, %%item_cat%%, %%item_tags%%, %%item_read_more_button%%, %%item_show_image%%, %%item_image_URL%%, %%author%%, %%author_link%%, %%author_email%%, %%item_modified%%, %%item_created%%, %%item_conceived%%, %%item_is_mature%%, %%item_views%%, %%item_appreciations%%, %%item_comments%%, %%item_fields%%, %%item_creator_id%%, %%item_copyright%%, %%item_tools%%", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Post Custom Fields:", 'bhomatic-behance-post-generator');?></b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                                                      </td>
                                                      <td>
                                                      <textarea rows="1" cols="70" name="bhomatic_rules_list[custom_fields][]" placeholder="Please insert your desired custom fields. Example: title_custom_field => %%item_title%%" class="cr_width_full"></textarea>
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td class="cr_min_width_200">
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Set the custom taxonomies that will be set for generated posts. The syntax for this field is the following: custom_taxonomy_name1 => custom_taxonomy_value1A, custom_taxonomy_value1B; custom_taxonomy_name2 => custom_taxonomy_value2A, custom_taxonomy_value2B; ... . In custom_taxonomy_valueX, you can use shortcodes. Example (without quotes): 'cats_taxonomy_field => manualtax1, %%auto_tax%%; tags_taxonomy_field => manualtax2, %%auto_tax%%'. You can use the following shortcodes: %%auto_tax%%, %%item_pub_date%%, %%custom_html%%, %%custom_html2%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_content_plain_text%%, %%item_url%%, %%item_cat%%, %%item_tags%%, %%item_read_more_button%%, %%item_show_image%%, %%item_image_URL%%, %%author%%, %%author_link%%, %%author_email%%, %%item_modified%%, %%item_created%%, %%item_conceived%%, %%item_is_mature%%, %%item_views%%, %%item_appreciations%%, %%item_comments%%, %%item_fields%%, %%item_creator_id%%, %%item_copyright%%, %%item_tools%%", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Post Custom Taxonomies:", 'bhomatic-behance-post-generator');?></b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                                                      </td>
                                                      <td>
                                                      <textarea rows="1" cols="70" name="bhomatic_rules_list[custom_tax][]" placeholder="Please insert your desired custom taxonomies. Example: custom_taxonomy_name => %%item_cats%%" class="cr_width_full"></textarea>
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Do you want to set featured image for generated post (to the first image that was found in the post)?", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Auto Get Featured Image:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="checkbox" id="featured_image" name="bhomatic_rules_list[featured_image][]" checked>
                                                      </div>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                            <div class="bws_hidden_help_text cr_min_260px">
                                                               <?php
                                                                  echo esc_html__("Insert a comma separated list of links to valid images that will be set randomly for the featured image for the posts that do not have a valid image attached or if you disabled automatical featured image generation. You can also use image numeric IDs from images found in the Media Gallery. To disable this feature, leave this field blank.", 'bhomatic-behance-post-generator');
                                                                  ?>
                                                            </div>
                                                         </div>
                                                         <b><?php echo esc_html__("Default Featured Image List:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                         <input class="cr_width_60p" type="text" name="bhomatic_rules_list[image_url][]" placeholder="Please insert the link to a valid image" id="cr_input_box"  value=""/>
                                                         <input class="cr_width_33p bhomatic_image_button" type="button" value=">>>"/>
                                                      </td>
                                                   </tr>
                                                   <tr>
                                                      <td>
                                                         <div>
                                                            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                               <div class="bws_hidden_help_text cr_min_260px">
                                                                  <?php
                                                                     echo esc_html__("Input a short description for the current rule. This will appear in the help for for the current rule, next to rule's ID. This field is not used in plugin's activity and running.", 'bhomatic-behance-post-generator');
                                                                     ?>
                                                               </div>
                                                            </div>
                                                            <b><?php echo esc_html__("Short Rule Description:", 'bhomatic-behance-post-generator');?></b>
                                                      </td>
                                                      <td>
                                                      <input type="text" id="rule_description" name="bhomatic_rules_list[rule_description][]" value="" placeholder="Input a description" class="cr_width_full">
                                                      </div>
                                                      </td>
                                                   </tr>
                                                </table>
                                             </div>
                                          </div>
                                          <div class="codemodalfzr-footer">
                                             <br/>
                                             <h3 class="cr_inline">Behanceomatic Automatic Post Generator</h3>
                                             <span id="bhomatic_ok" class="codeokfzr cr_inline">OK&nbsp;</span>
                                             <br/><br/>
                                          </div>
                                       </div>
                                    </div>
                                 </td>
                                 <td class="cr_shrt_td2"><span class="cr_gray20">X</span></td>
                                 <td class="cr_short_td"><input type="checkbox" name="bhomatic_rules_list[active][]" value="1" checked />
                                    <input type="hidden" name="bhomatic_rules_list[last_run][]" value="1988-01-27 00:00:00"/>
                                 </td>
                                 <td class="cr_short_td">
                                    <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                       <div class="bws_hidden_help_text cr_min_260px">
                                          <?php
                                             echo esc_html__("No info.", 'bhomatic-behance-post-generator');
                                             ?>
                                       </div>
                                    </div>
                                 </td>
                                 <td class="cr_center">
                                    <div>
                                       <img src="<?php
                                          echo esc_url_raw(plugin_dir_url(dirname(__FILE__)) . 'images/running.gif');
                                          ?>" alt="Running" class="cr_running">
                                       <div class="codemainfzr cr_gray_back">
                                          <select id="actions" class="actions" name="actions" disabled>
                                             <option value="select" disabled selected><?php echo esc_html__("Select an Action", 'bhomatic-behance-post-generator');?></option>
                                             <option value="run" onclick=""><?php echo esc_html__("Run This Rule Now", 'bhomatic-behance-post-generator');?></option>
                                             <option value="trash" onclick=""><?php echo esc_html__("Move All Posts To Trash", 'bhomatic-behance-post-generator');?></option>
                                             <option value="delete" onclick=""><?php echo esc_html__("Permanently Delete All Posts", 'bhomatic-behance-post-generator');?></option>
                                          </select>
                                       </div>
                                    </div>
                                 </td>
                              </tr>
                           </tbody>
                        </table>
                     </div>
                  </div>
               </div>
               <hr/>
               <div>
                  <p class="crsubmit"><input type="submit" name="btnSubmit" id="btnSubmit" class="button button-primary" onclick="unsaved = false;" value="<?php echo esc_html__("Save Settings", 'bhomatic-behance-post-generator');?>"/></p>
               </div>
               <div>
                  <?php echo esc_html__("New! AI generated shortcodes supported, click for details:", 'bhomatic-behance-post-generator');?>&nbsp;<a href="https://coderevolution.ro/knowledge-base/faq/how-to-create-ai-generated-content-from-any-plugin-built-by-coderevolution/" target="_blank"><img src="https://i.ibb.co/gvTNWr6/artificial-intelligence-badge.png" alt="artificial-intelligence-badge" title="AI content generator support, when used together with the Aiomatic plugin"></a><br/><br/><a href="https://www.youtube.com/watch?v=5rbnu_uis7Y" target="_blank"><?php echo esc_html__("Nested Shortcodes also supported!", 'bhomatic-behance-post-generator');?></a><br/><?php echo esc_html__("Confused about rule running status icons?", 'bhomatic-behance-post-generator');?> <a href="http://coderevolution.ro/knowledge-base/faq/how-to-interpret-the-rule-running-visual-indicators-red-x-yellow-diamond-green-tick-from-inside-plugins/" target="_blank"><?php echo esc_html__("More info", 'bhomatic-behance-post-generator');?></a><br/>
                  <div class="cr_none" id="midas_icons">
                     <table>
                        <tr>
                           <td><img id="run_img" src="<?php echo esc_url_raw(plugin_dir_url(dirname(__FILE__)) . 'images/running.gif');?>" alt="Running" title="status"></td>
                           <td><?php echo esc_html__("In Progress", 'bhomatic-behance-post-generator');?> - <b><?php echo esc_html__("Importing is Running", 'bhomatic-behance-post-generator');?></b></td>
                        </tr>
                        <tr>
                           <td><img id="ok_img" src="<?php echo esc_url_raw(plugin_dir_url(dirname(__FILE__)) . 'images/ok.gif');?>" alt="OK"  title="status"></td>
                           <td><?php echo esc_html__("Success", 'bhomatic-behance-post-generator');?> - <b><?php echo esc_html__("New Posts Created", 'bhomatic-behance-post-generator');?></b></td>
                        </tr>
                        <tr>
                           <td><img id="fail_img" src="<?php echo esc_url_raw(plugin_dir_url(dirname(__FILE__)) . 'images/failed.gif');?>" alt="Faield" title="status"></td>
                           <td><?php echo esc_html__("Failed", 'bhomatic-behance-post-generator');?> - <b><?php echo esc_html__("An Error Occurred.", 'bhomatic-behance-post-generator');?> <b><?php echo esc_html__("Please check 'Activity and Logging' plugin menu for details.", 'bhomatic-behance-post-generator');?></b></td>
                        </tr>
                        <tr>
                           <td><img id="nochange_img" src="<?php echo esc_url_raw(plugin_dir_url(dirname(__FILE__)) . 'images/nochange.gif');?>" alt="NoChange" title="status"></td>
                           <td><?php echo esc_html__("No Change - No New Posts Created", 'bhomatic-behance-post-generator');?> - <b><?php echo esc_html__("Possible reasons:", 'bhomatic-behance-post-generator');?></b></td>
                        </tr>
                        <tr>
                           <td></td>
                           <td>
                              <ul>
                                 <li>&#9658; <?php echo esc_html__("Already all posts are published that match your search and posts will be posted when new content will be available", 'bhomatic-behance-post-generator');?></li>
                                 <li>&#9658; <?php echo esc_html__("Some restrictions you defined in the plugin's 'Main Settings'", 'bhomatic-behance-post-generator');?> <i>(<?php echo esc_html__("example: 'Minimum Content Word Count', 'Maximum Content Word Count', 'Minimum Title Word Count', 'Maximum Title Word Count', 'Banned Words List', 'Reuired Words List', 'Skip Posts Without Images'", 'bhomatic-behance-post-generator');?>)</i> <?php echo esc_html__("prevent posting of new posts.", 'bhomatic-behance-post-generator');?></li>
                              </ul>
                           </td>
                        </tr>
                     </table>
                  </div>
               </div>
            </form>
         </div>
      </div>
   </div>
</div>
<?php
   }
   if (isset($_POST['bhomatic_rules_list'])) {
       add_action('admin_init', 'bhomatic_save_rules_manual');
   }
   
   function bhomatic_save_rules_manual($data2)
   {
       check_admin_referer('bhomatic_save_rules', '_bhomaticr_nonce');
       
       $data2 = $_POST['bhomatic_rules_list'];
       $rules = array();
       $cont  = 0;
       $cat_cont  = 0;
       if (isset($data2['textids'][0])) {
           for ($i = 0; $i < sizeof($data2['textids']); ++$i) {
               $bundle = array();
               if (isset($data2['schedule'][$i]) && $data2['schedule'][$i] != '' && $data2['textids'][$i] != '') {
                   $bundle[] = trim(sanitize_text_field($data2['textids'][$i]));
                   $bundle[] = trim(sanitize_text_field($data2['schedule'][$i]));
                   if (isset($data2['active'][$i])) {
                       $bundle[] = trim(sanitize_text_field($data2['active'][$i]));
                   } else {
                       $bundle[] = '0';
                   }
                   $bundle[]     = trim(sanitize_text_field($data2['last_run'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['max'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['submit_status'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['default_type'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_author'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['default_tags'][$i]));
                   if($i == sizeof($data2['textids']) - 1)
                   {
                       if(isset($data2['default_category']))
                       {
                           $bundle[]     = $data2['default_category'];
                       }
                       else
                       {
                           if(!isset($data2['default_category' . $cat_cont]))
                           {
                               $cat_cont++;
                           }
                           if(!isset($data2['default_category' . $cat_cont]))
                           {
                               $bundle[]     = array('bhomatic_no_category_12345678');
                           }
                           else
                           {
                               $bundle[]     = $data2['default_category' . $cat_cont];
                           }
                       }
                   }
                   else
                   {
                       if(!isset($data2['default_category' . $cat_cont]))
                       {
                           $cat_cont++;
                       }
                       if(!isset($data2['default_category' . $cat_cont]))
                       {
                           $bundle[]     = array('bhomatic_no_category_12345678');
                       }
                       else
                       {
                           $bundle[]     = $data2['default_category' . $cat_cont];
                       }
                   }
                   $bundle[]     = trim(sanitize_text_field($data2['auto_categories'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['auto_tags'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['enable_comments'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['featured_image'][$i]));
                   $bundle[]     = trim($data2['image_url'][$i]);
                   $bundle[]     = $data2['post_title'][$i];
                   $bundle[]     = $data2['post_content'][$i];
                   $bundle[]     = trim(sanitize_text_field($data2['enable_pingback'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_format'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['strip_images'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['limit_title_word_count'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['original_date'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['strip_text'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['remove_default'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_type_filter'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['no_excerpt'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['rule_description'][$i]));
                   $bundle[]     = trim($data2['custom_fields'][$i]);
                   $bundle[]     = trim($data2['custom_tax'][$i]);
                   $bundle[]     = trim(sanitize_text_field($data2['require_words'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['banned_words'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['continue_search'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['get_details'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['skip_mature'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_sort'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_time'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_field'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_contry'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_state'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_city'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_tags'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['color_hex'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['color_range'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_license'][$i]));
                   $rules[$cont] = $bundle;
                   $cont++;
                   $cat_cont++;
               }
           }
       }
       update_option('bhomatic_rules_list', $rules, false);
   }
   function bhomatic_expand_rules_manual()
   {
       if (!get_option('bhomatic_running_list')) {
           $running = array();
       } else {
           $running = get_option('bhomatic_running_list');
       }
       $GLOBALS['wp_object_cache']->delete('bhomatic_rules_list', 'options');
       $rules  = get_option('bhomatic_rules_list');
    if(!is_array($rules))
    {
       $rules = array();
    }
       $output = '';
       $cont   = 0;
       if (!empty($rules)) {
           $posted_items = array();
           
           $post_list = array();
           $postsPerPage = 50000;
           $paged = 0;
           do
           {
               $postOffset = $paged * $postsPerPage;
               $query = array(
                   'post_status' => array(
                       'publish',
                       'draft',
                       'pending',
                       'trash',
                       'private',
                       'future'
                   ),
                   'post_type' => array(
                       'any'
                   ),
                   'numberposts' => $postsPerPage,
                   'meta_key' => 'bhomatic_parent_rule',
                   'fields' => 'ids',
                   'offset'  => $postOffset
               );
               $got_me = get_posts($query);
               $post_list = array_merge($post_list, $got_me);
               $paged++;
           }while(!empty($got_me));
           
           wp_suspend_cache_addition(true);
           foreach ($post_list as $post) {
               $rule_id = get_post_meta($post, 'bhomatic_parent_rule', true);
               if ($rule_id != '') {
                   $posted_items[] = $rule_id;
               }
           }
           wp_suspend_cache_addition(false);
           $unlocker = get_option('bhomatic_minute_running_unlocked', false);
           $counted_vals = array_count_values($posted_items);
           foreach ($rules as $request => $bundle[]) {
               if (isset($counted_vals[$cont])) {
                   $generated_posts = $counted_vals[$cont];
               } else {
                   $generated_posts = 0;
               }
               $bundle_values          = array_values($bundle);
               $myValues               = $bundle_values[$cont];
               $array_my_values        = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
               $textids                = $array_my_values[0];
               $schedule               = $array_my_values[1];
               $active                 = $array_my_values[2];
               $last_run               = $array_my_values[3];
               $max                    = $array_my_values[4];
               $status                 = $array_my_values[5];
               $def_type               = $array_my_values[6];
               $post_user_name         = $array_my_values[7];
               $default_tags           = $array_my_values[8];
               $default_category       = $array_my_values[9];
               $auto_categories        = $array_my_values[10];
               $auto_tags              = $array_my_values[11];
               $enable_comments        = $array_my_values[12];
               $featured_image         = $array_my_values[13];
               $image_url              = $array_my_values[14];
               $post_title             = $array_my_values[15];
               $post_content           = $array_my_values[16];
               $enable_pingback        = $array_my_values[17];
               $post_format            = $array_my_values[18];
               $strip_images           = $array_my_values[19];
               $limit_title_word_count = $array_my_values[20];
               $original_date          = $array_my_values[21];
               $strip_text             = $array_my_values[22];
               $remove_default         = $array_my_values[23];
               $post_type_filter       = $array_my_values[24];
               $no_excerpt             = $array_my_values[25];
               $rule_description       = $array_my_values[26];
               $custom_fields          = $array_my_values[27];
               $custom_tax             = $array_my_values[28];
               $require_words          = $array_my_values[29];
               $banned_words           = $array_my_values[30];
               $continue_search        = $array_my_values[31];
               $get_details            = $array_my_values[32];
               $skip_mature            = $array_my_values[33];
               $post_sort              = $array_my_values[34];
               $post_time              = $array_my_values[35];
               $post_field             = $array_my_values[36];
               $post_contry            = $array_my_values[37];
               $post_state             = $array_my_values[38];
               $post_city              = $array_my_values[39];
               $post_tags              = $array_my_values[40];
               $color_hex              = $array_my_values[41];
               $color_range            = $array_my_values[42];
               $post_license           = $array_my_values[43];
               wp_add_inline_script('bhomatic-footer-script', 'createAdmin(' . esc_html($cont) . ');', 'after');
               $output .= '<tr>
                           <td class="cr_short_td">' . $cont;
               if($rule_description != '')
               {
                   $output .= '&nbsp;<div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle"><div class="bws_hidden_help_text cr_min_260px">' . esc_html__($rule_description, 'bhomatic-behance-post-generator') . '</div></div>';
               }
               $output .= '</td>
   						<td class="cr_comm_td"><input type="text" name="bhomatic_rules_list[textids][]" placeholder="Search query" class="cr_width_full" value="' . esc_attr($textids) . '" class="cr_width_full"/></td><td class="cr_comm_td"><input type="number" step="1" min="1" placeholder="# h" name="bhomatic_rules_list[schedule][]" max="8765812" value="' . esc_attr($schedule) . '" class="cr_width_60" required></td>
                           <td class="cr_comm_td"><input type="number" step="1" min="0" placeholder="# max" max="200" name="bhomatic_rules_list[max][]" value="' . esc_attr($max) . '"  class="cr_width_60" required></td>
                           <td class="cr_status"><select id="submit_status" name="bhomatic_rules_list[submit_status][]" class="cr_width_70">
                                     <option value="pending"';
               if ($status == 'pending') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Pending -> Moderate", 'bhomatic-behance-post-generator') . '</option>
                                     <option value="draft"';
               if ($status == 'draft') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Draft -> Moderate", 'bhomatic-behance-post-generator') . '</option>
                                     <option value="publish"';
               if ($status == 'publish') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Published", 'bhomatic-behance-post-generator') . '</option>
                                     <option value="private"';
               if ($status == 'private') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Private", 'bhomatic-behance-post-generator') . '</option>
                                     <option value="trash"';
               if ($status == 'trash') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Trash", 'bhomatic-behance-post-generator') . '</option>
                       </select>  </td>
                       <td class="cr_comm_td"><select id="default_type" name="bhomatic_rules_list[default_type][]" class="cr_width_auto">';
               foreach ( get_post_types( '', 'names' ) as $post_type ) {
                  $output .= '<option value="' . esc_attr($post_type) . '"';
                  if ($def_type == $post_type) {
                       $output .= ' selected';
                   }
                  $output .= '>' . esc_html($post_type) . '</option>';
               }
               $output .= '</select>  </td>
                       <td class="cr_author"><select id="post_author" name="bhomatic_rules_list[post_author][]" class="cr_width_auto cr_max_width_150">';
               $blogusers = get_users( [ 'role__in' => [ 'contributor', 'author', 'editor', 'administrator' ] ] );
               foreach ($blogusers as $user) {
                   $output .= '<option value="' . esc_html($user->ID) . '"';
                   if ($post_user_name == $user->ID) {
                       $output .= " selected";
                   }
                   $output .= '>' . esc_html($user->display_name) . '</option>';
               }
               $output .= '</select>  </td>
                       <td class="cr_width_70">
                       <input type="button" id="mybtnfzr' . esc_html($cont) . '" value="Settings">
                       <div id="mymodalfzr' . esc_html($cont) . '" class="codemodalfzr">
     <div class="codemodalfzr-content">
       <div class="codemodalfzr-header">
         <span id="bhomatic_close' . esc_html($cont) . '" class="codeclosefzr">&times;</span>
         <h2>' . esc_html__('Rule', 'bhomatic-behance-post-generator') . ' <span class="cr_color_white">ID ' . esc_html($cont) . '</span> ' . esc_html__('Advanced Settings', 'bhomatic-behance-post-generator') . '</h2>
       </div>
       <div class="codemodalfzr-body">
       <div class="table-responsive">
         <table class="responsive table cr_main_table_nowr">
       <tr><td class="cr_min_width_200">
       <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the title of the generated posts for user rules. You can use the following shortcodes:  %%item_short_content%%, %%author%%, %%item_description%%, %%item_date%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_cat%%, %%item_tags%%", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Generated Post Title", 'bhomatic-behance-post-generator') . ':</b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                       
                       </td><td>
                       <input type="text" name="bhomatic_rules_list[post_title][]" value="' . esc_attr(htmlspecialchars($post_title)) . '" placeholder="Please insert your desired post title. Example: %%item_title%%" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the content of the generated posts for user rules. You can use the following shortcodes:  %%item_date%%, %%custom_html%%, %%custom_html2%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_content_plain_text%%, %%item_url%%, %%item_cat%%, %%item_tags%%, %%item_read_more_button%%, %%item_show_image%%, %%item_image_URL%%, %%author%%, %%author_link%%, %%item_modified%%, %%item_created%%, %%item_conceived%%, %%item_is_mature%%, %%item_views%%, %%item_appreciations%%, %%item_comments%%, %%item_fields%%, %%item_creator_id%%, %%item_copyright%%, %%item_tools%%", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Generated Post Content", 'bhomatic-behance-post-generator') . ':</b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                       
                       </td><td>
                       <textarea rows="2" cols="70" name="bhomatic_rules_list[post_content][]" placeholder="Please insert your desired post content. Example:%%item_content%%" class="cr_width_full">' . htmlspecialchars($post_content) . '</textarea>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Select the Behance post type you want to skip. Possible values are: text, image, embed, media_collection, audio, video.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Behance Post Types To Skip", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="post_type_filter" name="bhomatic_rules_list[post_type_filter][]" value="' . esc_attr($post_type_filter) . '" placeholder="Input a list of post types" class="cr_width_full">                  
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to get additional information for each project? Please note that this feature will make one additional API request for each posted project. If you uncheck this checkbox, the following shortcodes will become unavailable: %%item_fields%%, %%item_creator_id%%, %%item_copyright%%, %%item_tools%%, %%item_content%%", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Get Detailed Info For Projects", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="get_details" name="bhomatic_rules_list[get_details][]"';
               if ($get_details == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to get additional information for each project? Please note that this feature will make one additional API request for each posted project.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Skip Mature Content", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="skip_mature" name="bhomatic_rules_list[skip_mature][]"';
               if ($skip_mature == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to remember last posted item and continue search from it the next time the importing rule runs?", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Cache Items For Continuous Posting (disable to get latest posts only)", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="continue_search" name="bhomatic_rules_list[continue_search][]"';
               if ($continue_search == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("The order the results are returned in. Possible values: featured_date (default), appreciations, views, comments, published_date.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Result Sorting", 'bhomatic-behance-post-generator') . ':</b>   
                       </td><td class="cr_min_width_200">
                       <select id="post_sort" name="bhomatic_rules_list[post_sort][]" class="cr_width_full">
                       <option value="featured_date"';
               if ($post_sort == 'featured_date') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Featured Date", 'bhomatic-behance-post-generator') . '</option>
                       <option value="appreciations"';
               if ($post_sort == 'appreciations') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Appreciations", 'bhomatic-behance-post-generator') . '</option>
                       <option value="views"';
               if ($post_sort == 'views') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Views", 'bhomatic-behance-post-generator') . '</option>
                       <option value="comments"';
               if ($post_sort == 'comments') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Comments", 'bhomatic-behance-post-generator') . '</option>
                       <option value="published_date"';
               if ($post_sort == 'published_date') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Published Date", 'bhomatic-behance-post-generator') . '</option>
                   </select>     
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Limits the search by time. Possible values: all (default), today, week, month.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Search Time", 'bhomatic-behance-post-generator') . ':</b>   
                       </td><td class="cr_min_width_200">
                       <select id="post_time" name="bhomatic_rules_list[post_time][]" class="cr_width_full">
                       <option value="all"';
               if ($post_time == 'all') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("All", 'bhomatic-behance-post-generator') . '</option>
                       <option value="today"';
               if ($post_time == 'today') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Today", 'bhomatic-behance-post-generator') . '</option>
                       <option value="week"';
               if ($post_time == 'week') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Week", 'bhomatic-behance-post-generator') . '</option>
                       <option value="month"';
               if ($post_time == 'month') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Month", 'bhomatic-behance-post-generator') . '</option>
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Filter by creative license. Acronyms found here: http://creativecommons.org/licenses/", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Search License", 'bhomatic-behance-post-generator') . ':</b>   
                       </td><td class="cr_min_width_200">
                       <select id="post_license" name="bhomatic_rules_list[post_license][]" class="cr_width_full">
                       <option value="any"';
               if ($post_license == 'any') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Any", 'bhomatic-behance-post-generator') . '</option>
                       <option value="cc by"';
               if ($post_license == 'cc by') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("CC BY", 'bhomatic-behance-post-generator') . '</option>
                       <option value="cc by-sa"';
               if ($post_license == 'cc by-sa') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("CC BY-SA", 'bhomatic-behance-post-generator') . '</option>
                       <option value="cc by-nd"';
               if ($post_license == 'cc by-nd') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("CC BY-ND", 'bhomatic-behance-post-generator') . '</option>
                       <option value="cc by-nc"';
               if ($post_license == 'cc by-nc') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("CC BY-NC", 'bhomatic-behance-post-generator') . '</option>
                       <option value="cc by-nc-sa"';
               if ($post_license == 'cc by-nc-sa') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("CC BY-NC-SA", 'bhomatic-behance-post-generator') . '</option>
                       <option value="cc by-nc-nd"';
               if ($post_license == 'cc by-nc-nd') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("CC BY-NC-ND", 'bhomatic-behance-post-generator') . '</option>
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . sprintf( wp_kses( __( 'Limits the search by creative field. Accepts a URL-encoded field name from the list of defined creative fields. <a href=\'%s\' target=\'_blank\'>Value list (at the lower part of the page)</a>', 'bhomatic-behance-post-generator'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), esc_url_raw( 'https://www.behance.net/dev/api/endpoints/' ) ) . '
                           </div>
                       </div>
                       <b>' . esc_html__("Search Project Field", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="post_field" name="bhomatic_rules_list[post_field][]" value="' . esc_attr($post_field) . '" placeholder="Input a post field slug" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Limits the search by tags. Accepts one tag name or a pipe-separated list of tag names.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Search Project Tags", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="post_tags" name="bhomatic_rules_list[post_tags][]" value="' . esc_attr($post_tags) . '" placeholder="Input a post tag slug" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Limits the search by a 2-letter FIPS country code.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Search Country", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="post_contry" name="bhomatic_rules_list[post_contry][]" value="' . esc_attr($post_contry) . '" placeholder="Input a post country" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Limits the search by state or province name.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Search State", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="post_state" name="bhomatic_rules_list[post_state][]" value="' . esc_attr($post_state) . '" placeholder="Input a post state" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Limits the search by city name.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Search City", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="post_city" name="bhomatic_rules_list[post_city][]" value="' . esc_attr($post_city) . '" placeholder="Input a post city" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Limit results to an RGB hex value (without #)", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Search Color Hex", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="color_hex" name="bhomatic_rules_list[color_hex][]" value="' . esc_attr($color_hex) . '" placeholder="Input a color hex" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("How closely to match the requested color_hex, in color shades (default:20) [0-255]", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Search Color Range", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="color_range" name="bhomatic_rules_list[color_range][]" value="' . esc_attr($color_range) . '" placeholder="Input a color range" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to disable the automatic post excerpt generation?", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Disable Automatic Excerpt Generation", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="no_excerpt" name="bhomatic_rules_list[no_excerpt][]"';
               if ($no_excerpt == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to set post date as the original date from Behance?", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Set Post Original Date", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="original_date" name="bhomatic_rules_list[original_date][]"';
               if ($original_date == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to strip images from generated content?", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Strip Images From Content", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="strip_images" name="bhomatic_rules_list[strip_images][]"';
               if ($strip_images == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to strip title from generated content and leave only images and videos?", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Strip Title From Content", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="strip_text" name="bhomatic_rules_list[strip_text][]"';
               if ($strip_text == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("This feature will try to remove the WordPress\'s default post category. This may fail in case no additional categories are added, because WordPress requires at least one post category for every post.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Remove WP Default Post Category", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="remove_default" name="bhomatic_rules_list[remove_default][]"';
           if($remove_default == '1')
           {
               $output .= ' checked';
           }
           $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do not include posts that\'s title or content does not contain at least one of these words. Separate words by comma. To disable this feature, leave this field blank.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Required Words List", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="require_words" name="bhomatic_rules_list[require_words][]" value="' . esc_attr($require_words) . '" placeholder="Input some comma separated required words" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do not include posts that\'s title or content contains at least one of these words. Separate words by comma. To disable this feature, leave this field blank.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Banned Words List", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="banned_words" name="bhomatic_rules_list[banned_words][]" value="' . esc_attr($banned_words) . '" placeholder="Input some comma separated banned words" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to limit the title\'s length to a specific word count? To disable this feature, leave this field blank.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Limit Title Word Count", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="number" min="1" step="1" id="limit_title_word_count" name="bhomatic_rules_list[limit_title_word_count][]" value="' . esc_attr($limit_title_word_count) . '" placeholder="Input a limit for the title" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__('If your template supports "Post Formats", than you can select one here. If not, leave this at it\'s default value.', 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Generated Post Format", 'bhomatic-behance-post-generator') . ':</b>   
                       </td><td>
                       <select id="post_format" name="bhomatic_rules_list[post_format][]" class="cr_width_full">
                       <option value="post-format-standard"';
               if ($post_format == 'post-format-standard') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Standard", 'bhomatic-behance-post-generator') . '</option>
                       <option value="post-format-aside"';
               if ($post_format == 'post-format-aside') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Aside", 'bhomatic-behance-post-generator') . '</option>
                       <option value="post-format-gallery"';
               if ($post_format == 'post-format-gallery') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Gallery", 'bhomatic-behance-post-generator') . '</option>
                       <option value="post-format-link"';
               if ($post_format == 'post-format-link') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Link", 'bhomatic-behance-post-generator') . '</option>
                       <option value="post-format-image"';
               if ($post_format == 'post-format-image') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Image", 'bhomatic-behance-post-generator') . '</option>
                       <option value="post-format-quote"';
               if ($post_format == 'post-format-quote') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Quote", 'bhomatic-behance-post-generator') . '</option>
                       <option value="post-format-status"';
               if ($post_format == 'post-format-status') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Status", 'bhomatic-behance-post-generator') . '</option>
                       <option value="post-format-video"';
               if ($post_format == 'post-format-video') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Video", 'bhomatic-behance-post-generator') . '</option>
                       <option value="post-format-audio"';
               if ($post_format == 'post-format-audio') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Audio", 'bhomatic-behance-post-generator') . '</option>
                       <option value="post-format-chat"';
               if ($post_format == 'post-format-chat') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Chat", 'bhomatic-behance-post-generator') . '</option>
                   </select>     
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Select the post category that you want for the automatically generated posts to have.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Additional Post Category", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <select multiple class="cr_width_full" id="default_category" name="bhomatic_rules_list[default_category' . esc_html($cont) . '][]" onmouseover="this.size=this.length;" onmouseout="this.size=4;">
                       <option value="bhomatic_no_category_12345678"';
                       if(!is_array($default_category))
                       {
                           $default_category = array($default_category);
                       }
                       if(count($default_category) == 1)
                       {
                        foreach($default_category as $dc)
                        {
                              if ("bhomatic_no_category_12345678" == $dc) {
                                 $output .= ' selected';
                                 break;
                              }
                        }
                     }
                       $output .= '>' . esc_html__("Do Not Add a Category", 'bhomatic-behance-post-generator') . '</option>';
               $cat_args   = array(
                   "orderby" => "name",
                   "hide_empty" => 0,
                   "order" => "ASC"
               );
               $categories = get_categories($cat_args);
               
               foreach ($categories as $category) {
                   $output .= '<option value="' . esc_attr($category->term_id) . '"';
                   foreach($default_category as $dc)
                   {
                       if ($category->term_id == $dc) {
                           $output .= ' selected';
                           break;
                       }
                   }
                   $output .= '>' . sanitize_text_field($category->name) . '</option>';
               }
               $output .= '</select>      
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to automatically add post categories from the feed items?", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Auto Add Categories", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="auto_categories" name="bhomatic_rules_list[auto_categories][]"';
               if ($auto_categories == '1') {
                   $output .= ' checked';
               }
               $output .= '>               
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to automatically add post tags from the feed items?", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Auto Add Tags", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="auto_tags" name="bhomatic_rules_list[auto_tags][]"';
               if ($auto_tags == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Select the post tags that you want for the automatically generated posts to have.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Additional Post Tags", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input class="cr_width_full" type="text" name="bhomatic_rules_list[default_tags][]" value="' . esc_attr($default_tags) . '" placeholder="Please insert your additional post tags here" >
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to enable comments for the generated posts?", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Enable Comments For Posts", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="enable_comments" name="bhomatic_rules_list[enable_comments][]"';
               if ($enable_comments == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to enable pingbacks and trackbacks for the generated posts?", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Enable Pingback/Trackback", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="enable_pingback" name="bhomatic_rules_list[enable_pingback][]"';
               if ($enable_pingback == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the custom fields that will be set for generated posts. The syntax for this field is the following: custom_field_name1 => custom_field_value1, custom_field_name2 => custom_field_value2, ... . In custom_field_valueX, you can use shortcodes, same like in post content. You can also assign the data to array custom fields, using this format: array_field[index_name1] => custom_field_value1, array_field[index_name2] => custom_field_value2. Example (without quotes): \'title_custom_field => %%item_title%%\'. You can use the following shortcodes: %%item_pub_date%%, %%custom_html%%, %%custom_html2%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_content_plain_text%%, %%item_url%%, %%item_cat%%, %%item_tags%%, %%item_read_more_button%%, %%item_show_image%%, %%item_image_URL%%, %%author%%, %%author_link%%, %%author_email%%, %%item_modified%%, %%item_created%%, %%item_conceived%%, %%item_is_mature%%, %%item_views%%, %%item_appreciations%%, %%item_comments%%, %%item_fields%%, %%item_creator_id%%, %%item_copyright%%, %%item_tools%%", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Post Custom Fields", 'bhomatic-behance-post-generator') . ':</b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                       
                       </td><td>
                       <textarea rows="1" cols="70" name="bhomatic_rules_list[custom_fields][]" placeholder="Please insert your desired custom fields. Example: title_custom_field => %%item_title%%" class="cr_width_full">' . esc_textarea($custom_fields) . '</textarea>
                           
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the custom taxonomies that will be set for generated posts. The syntax for this field is the following: custom_taxonomy_name1 => custom_taxonomy_value1A, custom_taxonomy_value1B; custom_taxonomy_name2 => custom_taxonomy_value2A, custom_taxonomy_value2B; ... . In custom_taxonomy_valueX, you can use shortcodes. Example (without quotes): \'cats_taxonomy_field => manualtax1, %%auto_tax%%; tags_taxonomy_field => manualtax2, %%auto_tax%%\'. You can use the following shortcodes: %%auto_tax%%, %%item_pub_date%%, %%custom_html%%, %%custom_html2%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_content_plain_text%%, %%item_url%%, %%item_cat%%, %%item_tags%%, %%item_read_more_button%%, %%item_show_image%%, %%item_image_URL%%, %%author%%, %%author_link%%, %%author_email%%, %%item_modified%%, %%item_created%%, %%item_conceived%%, %%item_is_mature%%, %%item_views%%, %%item_appreciations%%, %%item_comments%%, %%item_fields%%, %%item_creator_id%%, %%item_copyright%%, %%item_tools%%", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Post Custom Taxonomies", 'bhomatic-behance-post-generator') . ':</b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                       </td><td>
                         <textarea rows="1" cols="70" name="bhomatic_rules_list[custom_tax][]" placeholder="Please insert your desired custom taxonomies. Example: custom_taxonomy_name => %%item_cats%%" class="cr_width_full">' . esc_textarea($custom_tax) . '</textarea>  
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to set featured image for generated post (to the first image that was found in the post)?", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Auto Get Featured Image", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="featured_image" name="bhomatic_rules_list[featured_image][]"';
               if ($featured_image == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Insert a comma separated list of links to valid images that will be set randomly for the featured image for the posts that do not have a valid image attached or if you disabled automatical featured image generation. You can also use image numeric IDs from images found in the Media Gallery. To disable this feature, leave this field blank.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Default Featured Image List", 'bhomatic-behance-post-generator') . ':</b>
                       </td><td>
                       <input class="cr_width_full" type="text" name="bhomatic_rules_list[image_url][]" placeholder="Please insert the link to a valid image" value="' . esc_attr($image_url) . '"/>
                       
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Input a short description for the current rule. This will appear in the help for for the current rule, next to rule\'s ID. This field is not used in plugin\'s activity and running.", 'bhomatic-behance-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Short Rule Description", 'bhomatic-behance-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="text" id="rule_description" name="bhomatic_rules_list[rule_description][]" value="' . esc_attr($rule_description) . '" placeholder="Input a description" class="cr_width_full">
                           
           </div>
           </td></tr></table></div> 
       </div>
       <div class="codemodalfzr-footer">
         <br/>
         <h3 class="cr_inline">Behanceomatic Automatic Post Generator</h3><span id="bhomatic_ok' . esc_html($cont) . '" class="codeokfzr cr_inline">OK&nbsp;</span>
         <br/><br/>
       </div>
     </div>
   
   </div>     
                       </td>
   						<td class="cr_shrt_td2"><span class="wpbhomatic-delete">X</span></td>
                           <td class="cr_short_td"><input type="checkbox" name="bhomatic_rules_list[active][]" class="activateDeactivateClass" value="1"';
               if (isset($active) && $active === '1') {
                   $output .= ' checked';
               }
               $output .= '/>
                           <input type="hidden" name="bhomatic_rules_list[last_run][]" value="' . esc_attr($last_run) . '"/></td>
                           <td class="cr_shrt_td2"><div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                           <div class="bws_hidden_help_text cr_min_260px">' . sprintf( wp_kses( __( 'Shortcode for this rule<br/>(to cross-post from this plugin in other plugins):', 'bhomatic-behance-post-generator'), array(  'br' => array( ) ) ) ) . '<br/><b>%%bhomatic_0_' . esc_html($cont) . '%% and %%bhomatic_title_0_' . esc_html($cont) . '%%</b><br/>' . esc_html__('Posts Generated:', 'bhomatic-behance-post-generator') . ' ' . esc_html($generated_posts) . '<br/>';
               if ($generated_posts != 0) {
                   $output .= '<a href="' . get_admin_url() . 'edit.php?coderevolution_post_source=Behanceomatic_' . esc_html($cont) . '&post_type=' . esc_html($def_type) . '" target="_blank">' . esc_html__('View Generated Posts', 'bhomatic-behance-post-generator') . '</a><br/>';
               }
               $output .= esc_html__('Last Run: ', 'bhomatic-behance-post-generator');
               if ($last_run == '1988-01-27 00:00:00') {
                   $output .= 'Never';
               } else {
                   $output .= $last_run;
               }
               $output .= '<br/>' . esc_html__('Next Run: ', 'bhomatic-behance-post-generator');
               if($unlocker == '1')
               {
                   $nextrun = bhomatic_add_minute($last_run, $schedule);
               }
               else
               {
                   $nextrun = bhomatic_add_hour($last_run, $schedule);
               }
               $now     = bhomatic_get_date_now();
               if ( defined( 'DISABLE_WP_CRON' ) && DISABLE_WP_CRON ) {
                   $output .= esc_html__('WP-CRON Disabled. Rules will not automatically run!', 'bhomatic-behance-post-generator');
               }
               else
               {
                   if (isset($active) && $active === '1') {
                       if($unlocker == '1')
                       {
                           $bhomatic_hour_diff = (int)bhomatic_minute_diff($now, $nextrun);
                       }
                       else
                       {
                           $bhomatic_hour_diff = (int)bhomatic_hour_diff($now, $nextrun);
                       }
                       if ($bhomatic_hour_diff >= 0) {
                           if($unlocker == '1')
                           {
                               $append = 'Now.';
                           }
                           else
                           {
                               $append = 'Now.';
                           }
                           $cron   = _get_cron_array();
                           if ($cron != FALSE) {
                               $date_format = _x('Y-m-d H:i:s', 'Date Time Format1', 'bhomatic-behance-post-generator');
                               foreach ($cron as $timestamp => $cronhooks) {
                                   foreach ((array) $cronhooks as $hook => $events) {
                                       if ($hook == 'bhomaticaction') {
                                           foreach ((array) $events as $key => $event) {
                                               $append = date_i18n($date_format, $timestamp);
                                           }
                                       }
                                   }
                               }
                           }
                           $output .= $append;
                       } else {
                           $output .= $nextrun;
                       }
                   } else {
                       $output .= esc_html__('Rule Disabled', 'bhomatic-behance-post-generator');
                   }
               }
               $output .= '<br/>' . esc_html__('Local Time: ', 'bhomatic-behance-post-generator') . $now;
               $output .= '</div>
                       </div></td>
                           <td class="cr_center">
                           <div>
                           <img id="run_img' . esc_html($cont) . '" src="' . plugin_dir_url(dirname(__FILE__)) . 'images/running.gif' . '" alt="Running" class="cr_status_icon';
               if (!empty($running)) {
                   if (!in_array($cont, $running)) {
                       $output .= ' cr_hidden';
                   }
                   else
                   {
                       $f = fopen(get_temp_dir() . 'bhomatic_' . $cont, 'w');
                       if($f !== false)
                       {
                           if (!flock($f, LOCK_EX | LOCK_NB)) {
                           }
                           else
                           {
                               $output .= ' cr_hidden';
                               flock($f, LOCK_UN);
                               if (($xxkey = array_search($cont, $running)) !== false) {
                                   unset($running[$xxkey]);
                                   update_option('bhomatic_running_list', $running);
                               }
                           }
                       }
                   }
               } else {
                   $output .= ' cr_hidden';
               }
               $output .= '" title="status">
                           <div class="codemainfzr">
                           <select id="actions" class="actions" name="actions" onchange="actionsChangedManual(' . esc_html($cont) . ', this.value);" onfocus="this.selectedIndex = 0;">
                               <option value="select" disabled selected>' . esc_html__("Select an Action", 'bhomatic-behance-post-generator') . '</option>
                               <option value="run">' . esc_html__("Run This Rule Now", 'bhomatic-behance-post-generator') . '</option>
                               <option value="trash">' . esc_html__("Move All Posts To Trash", 'bhomatic-behance-post-generator') . '</option>
                               <option value="delete">' . esc_html__("Permanently Delete All Posts", 'bhomatic-behance-post-generator') . '</option>
                           </select>
                           </div>
                           </div>
                           </td>
   					</tr>	
   					';
               $cont = $cont + 1;
           }
       }
       return $output;
   }
   ?>